CREATE TRIGGER [SetAskingPrice] ON [dbo].[TRANS]
FOR INSERT
AS
DECLARE	@WorkID			as int,
		@TransID		as int,
		@aqPrice		as money,
		@sumNetPrice	as money,
		@countPriorRows as int,
		@newPrice		as money

/* Get the new values that a user is trying to insert this uses a special pseudotable named "inserted" */
SELECT	@WorkID=WorkID, 
		@aqPrice=AcquisitionPrice, 
		@TransID=TransactionID
FROM	inserted

SELECT	*
from	dbo.TRANS T
WHERE	T.WorkID=@WorkID
/* This is an after trigger so the count will include the current inserted row. Subtract it */
Set @countPriorRows=@@Rowcount-1
Set @newPrice=2*@aqPrice
/* can't use average function because current row will count in the divisor. USE @@Rowcount - 1 from above calculation */
IF @countPriorRows > 0
	BEGIN
		SELECT	@sumNetPrice=SUM(NetPrice)
		FROM	ArtistWorkNet AW
		WHERE	AW.WorkID=@WorkID
		GROUP BY AW.WorkID

		IF @newPrice < (@sumNetPrice / @countPriorRows)+@aqPrice
			SET @newPrice=(@sumNetPrice / @countPriorRows) + @aqPrice
	END

UPDATE	dbo.TRANS
SET		AskingPrice=@newPrice
WHERE	TransactionID=@TransID
